using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using Syncfusion.Windows.Forms.Grid;

namespace SyncGrid
{
    public partial class Form1 : Form
    {
     
        DataSet ds = new DataSet();
        GridModelDataBinder gridBinder = null;
        public Form1()
        {
            InitializeComponent();
        }

        private DataTable CreateGrandParent()
        {
            DataTable dtGrand = new DataTable();
            dtGrand.Columns.Add("GrandParentKey");
            dtGrand.Columns.Add("NoKey");
            dtGrand.Columns.Add("Data");
            dtGrand.Columns.Add("Button");
            dtGrand.Columns.Add("Check1", typeof(bool));

            DataRow dr = dtGrand.NewRow();
            dr[0] = 99;
            dr[1] = 0;
            dr[2] = "Data";
            dtGrand.Rows.Add(dr);
            return dtGrand;
        }

        private DataTable CreateParentTable()
        {
            DataTable dtParent = new DataTable();
            dtParent.Columns.Add("ParentKey");
            dtParent.Columns.Add("GrandParentKey");
            dtParent.Columns.Add("Data");
            dtParent.Columns.Add("Button");
            dtParent.Columns.Add("Check1", typeof(bool));

            DataRow dr = dtParent.NewRow();
            dr[0] = 1;
            dr[1] = 99;
            dr[2] = "Data";
            dtParent.Rows.Add(dr);
      
            dr = dtParent.NewRow();
            dr[0] = 2;
            dr[1] = 99;
            dr[2] = "C";
            dtParent.Rows.Add(dr);
            
            dr = dtParent.NewRow();           
            dr[0] = 3;
            dr[1] = 99;
            dr[2] = "Sup";
            dtParent.Rows.Add(dr);

            return dtParent;
        }

        private DataTable CreateChildTable()
        {
            DataTable dtChild = new DataTable();
            dtChild.Columns.Add("ChildKey");
            dtChild.Columns.Add("ParentKey");
            dtChild.Columns.Add("Data");
            dtChild.Columns.Add("Button");
            dtChild.Columns.Add("Check1", typeof(bool));

            DataRow dr = dtChild.NewRow();
            dr[0] = 4;
            dr[1] = 1;
            dr[2] = "Child";
            dtChild.Rows.Add(dr);
            return dtChild;
        }
        GridHierarchyLevel level0, level1, level2;

        /// <summary>
        /// Load Form1
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void Form1_Load(object sender, EventArgs e)
        {
            DataTable dtParent = CreateParentTable();
            DataTable dtChild = CreateChildTable();
            DataTable dtGrand = CreateGrandParent();

            ds.Tables.AddRange(new DataTable[] {dtGrand, dtParent, dtChild });

            ds.Relations.Add(new DataRelation("Grand2Parent", ds.Tables[0].Columns["GrandParentKey"], ds.Tables[1].Columns["GrandParentKey"]));
            ds.Relations.Add(new DataRelation("Parent2Child", ds.Tables[1].Columns["ParentKey"], ds.Tables[2].Columns["ParentKey"]));
            
            
           
            this.dgrd.DataSource = ds;
            this.dgrd.DataMember = dtGrand.TableName;

            this.dgrd.Model.Options.ResizeColsBehavior |= GridResizeCellsBehavior.InsideGrid;

            this.dgrd.TableStyle.WrapText = false;

            //this.dgrd.CurrentCell.MoveTo(this.dgrd.Model.Rows.HeaderCount + 1, 3);
            this.dgrd.Binder.EnableAddNew = false;
            this.dgrd.Properties.BackgroundColor = SystemColors.Window;

            level0 = this.dgrd.Binder.RootHierarchyLevel;
            level1 = this.dgrd.Binder.AddRelation("Grand2Parent");
            level2 = this.dgrd.Binder.AddRelation("Parent2Child");
        

            level1.ShowHeaders = false;



            dgrd.Binder.InternalColumns["Button"].StyleInfo.CellType = "Button";

            this.dgrd.Model.QueryCellInfo += new GridQueryCellInfoEventHandler(ModelQueryCellInfo);
            
            

          
	
        }

        void ModelQueryCellInfo(object sender, GridQueryCellInfoEventArgs e)
        {
            GridModel model = ((IGridModelSource)sender).Model;
            int rowIndex = e.RowIndex;
            if (rowIndex > model.Rows.HeaderCount)
            {
                
                int colIndex = e.ColIndex;
            
                if (colIndex == dgrd.NameToColIndex("Button"))
                {
                    e.Style.HorizontalAlignment = GridHorizontalAlignment.Center;
                    e.Style.VerticalAlignment = GridVerticalAlignment.Middle;
                    e.Style.CellType = "PushButton";
                    e.Style.Description = "Click Me!";
                }
            }
        }

        

     

    
    }
}