using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using Syncfusion.Windows.Forms.Grid;

namespace SyncGrid
{
    public partial class Form2 : Form
    {
        public Form2()
        {
            InitializeComponent();
       }

        private DataTable Pop_Grid()
        {
            DataTable dt = new DataTable();
            dt.Columns.Add("ReportCheck", typeof(bool));
            dt.Columns.Add("SubCheck", typeof(bool));
            //dt.Columns.
            dt.Columns.Add("ReportID");
            dt.Columns.Add("ReportName");
           
            dt.Columns.Add("SubID");
            dt.Columns.Add("SubName");
            dt.Columns.Add("tag");

            DataRow dr = dt.NewRow();
            dr.ItemArray = new object[] { true, null, "1", "R1", "", null, "R" };
            dt.Rows.Add(dr);
            dr = dt.NewRow();
            dr.ItemArray = new object[] { null, false, "1", "R1", "S1", "SName", "S" };
            dt.Rows.Add(dr);
            return dt;
        }

        private void Form2_Load(object sender, EventArgs e)
        {
            DataTable dt = Pop_Grid();
            DataView dv = dt.DefaultView;
            dv.RowFilter = "SubID <> 'S1' and tag = 'R'";
            gridDataBoundGrid1.DataSource = dv;
            gridDataBoundGrid1.Model.QueryCellInfo += new Syncfusion.Windows.Forms.Grid.GridQueryCellInfoEventHandler(Model_QueryCellInfo);

            GridBoundColumnsCollection column5 = (GridBoundColumnsCollection)this.gridDataBoundGrid1.Binder.InternalColumns.Clone();
            GridBoundColumn Ucolumn5 = new GridBoundColumn();

            // Set Header Text and assign Mapping Name.
            Ucolumn5.MappingName = "Button";
            // Bind the unbound column to the grid.

            column5.Add(Ucolumn5);
            this.gridDataBoundGrid1.Binder.GridBoundColumns = column5;

            gridDataBoundGrid1.CellClick += new GridCellClickEventHandler(gridDataBoundGrid1_CellClick);
        }

        void gridDataBoundGrid1_CellClick(object sender, GridCellClickEventArgs e)
        {
            GridDataBoundGrid dg = (GridDataBoundGrid)sender;
            if (e.ColIndex == dg.NameToColIndex("Button"))
            {
                dg[e.RowIndex, e.ColIndex].Tag = !(bool)dg[e.RowIndex, e.ColIndex].Tag;
                //dg[e.RowIndex, e.ColIndex].Description = dg[e.RowIndex, e.ColIndex].Tag ? "-" : "+";

            }
        }

      
      

        void Model_QueryCellInfo(object sender, Syncfusion.Windows.Forms.Grid.GridQueryCellInfoEventArgs e)
        {
            GridDataBoundGridModel mod = (GridDataBoundGridModel)sender;
            GridDataBoundGrid dg = (GridDataBoundGrid)mod.ActiveGridView;
            if((e.ColIndex == dg.NameToColIndex("SubCheck") || (e.ColIndex == dg.NameToColIndex("SubID"))
                || (e.ColIndex == dg.NameToColIndex("SubName"))))
            switch (mod[e.RowIndex, dg.NameToColIndex("tag")].Text)
            {
                case "R" :
                    dg.Model.HideCols[dg.NameToColIndex("SubCheck")] = true;
                    dg.Model.HideCols[dg.NameToColIndex("SubID")] = true;
                    dg.Model.HideCols[dg.NameToColIndex("SubName")] = true;
                    break;
            }
            if (e.ColIndex == dg.NameToColIndex("Button"))
            {
                e.Style.HorizontalAlignment = GridHorizontalAlignment.Center;
                e.Style.VerticalAlignment = GridVerticalAlignment.Middle;
                e.Style.CellType = "PushButton";
                //e.Style.Description = "+";
                //false indicates Collapsed
                e.Style.Tag = false;
                //e.Style.ImageList = imageList1;
                //e.Style.ImageIndex = 1;
            }
        }
    }
}