using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using Syncfusion.Windows.Forms.Grid;
using System.Collections;
namespace SyncGrid
{
    public partial class Form3 : Form
    {
        public Form3()
        {
            InitializeComponent();
        }

        int noClick = 0;

        private DataTable CreateReportTable()
        {
            DataTable dt = new DataTable();
            dt.Columns.Add("ReportID");
            dt.Columns.Add("ReportName");
            DataRow dr = dt.NewRow();
            dr[0] = 23;
            dr[1] = "R1";
            dt.Rows.Add(dr);
            return dt;
        }
        GridHierarchyLevel level0, level1, level2, level3;
        private void Form3_Load(object sender, EventArgs e)
        {
            #region Completed thru First Version of XML
            /*DataSet dsRe = new DataSet();
            DataSet ds = new DataSet();
            dsRe.ReadXml("Reports.xml");
            ds.ReadXml("Subscriptions.xml");
            DataSet dsR = new DataSet();
            DataTable dt = dsRe.Tables[0].Copy();
            DataTable dtt = ds.Tables[0].Copy();
   
            dsR.Tables.AddRange(new DataTable[] { dt, dtt });

            dsR.Relations.Add("Report2Subscriptions", dsR.Tables[0].Columns["Report_ID"],
                dsR.Tables[1].Columns["REPORT_ID"]);

            dgrd.DataSource = dsR;
            dgrd.DataMember = dsR.Tables[0].TableName;

            this.dgrd.Model.Options.ResizeColsBehavior |= GridResizeCellsBehavior.InsideGrid;
            this.dgrd.TableStyle.WrapText = false;
            this.dgrd.Binder.EnableAddNew = false;
            this.dgrd.Properties.BackgroundColor = SystemColors.Window;

            level0 = this.dgrd.Binder.RootHierarchyLevel;
            level1 = this.dgrd.Binder.AddRelation("Report2Subscriptions");

            this.dgrd.Model.Options.ResizeColsBehavior |= GridResizeCellsBehavior.InsideGrid;

            dgrd.Model.Options.DefaultGridBorderStyle = GridBorderStyle.None;*/

            #endregion

            #region New Version of XML

            DataSet dsReports = new DataSet();
            DataSet dsPackage = new DataSet();
            DataSet dsSubPackage = new DataSet();
            DataSet dsSubscriptions = new DataSet();

            dsPackage.ReadXml("Packages.xml");
            dsSubPackage.ReadXml("SubPackages.xml");
            dsReports.ReadXml("Reports.xml");
            dsSubscriptions.ReadXml("Subscriptions.xml");

            //create Package Table
            DataTable dtPackage = new DataTable();
            dtPackage.Columns.Add("Package_ID");
            dtPackage.Columns.Add("Package_Name");
            dtPackage.Columns.Add("Check", typeof(bool));

            //Create Sub Package Table
            DataTable dtSubPackage = new DataTable();
            dtSubPackage.Columns.Add("Sub_Package_ID");
            dtSubPackage.Columns.Add("Sub_Package_Name");
            dtSubPackage.Columns.Add("Package_ID");
            dtSubPackage.Columns.Add("Check", typeof(bool));

            //Create Report Table
            DataTable dtReports = new DataTable();
            dtReports.Columns.Add("Report_ID");
            dtReports.Columns.Add("Sub_Package_ID");
            dtReports.Columns.Add("Check", typeof(bool));

            //Create Subscription Table
            DataTable dtSubscript = new DataTable();
            dtSubscript.Columns.Add("Report_ID");
            dtSubscript.Columns.Add("Report");
            dtSubscript.Columns.Add("Domain");

            Hashtable htPackageID = new Hashtable();
            Hashtable htSubPackageID_PackageID = new Hashtable();

            //Populate Reports Table
            for (int i = 0; i < dsReports.Tables[0].Rows.Count; i++)
            {
                DataRow dr = dtReports.NewRow();
                dr["Report_ID"] = dsReports.Tables[0].Rows[i]["REPORT_ID"].ToString();
                dr["Sub_Package_ID"] = dsReports.Tables[0].Rows[i]["SUB_PACKAGE_ID"].ToString();
                    
                dtReports.Rows.Add(dr);
                   if(!(htSubPackageID_PackageID.Contains(dsReports.Tables[0].Rows[i]
                    ["SUB_PACKAGE_ID"].ToString())))
                htSubPackageID_PackageID.Add(dsReports.Tables[0].Rows[i]
                    ["SUB_PACKAGE_ID"].ToString(), dsReports.Tables[0].Rows[i]
                    ["PACKAGE_ID"].ToString());
            }

            //Populate Package Table
            for (int i = 0; i<dsPackage.Tables[0].Rows.Count ; i++)
            {
               /* if (!(htPackageID.Contains(dsPackage.Tables[0].Rows[i]
                    ["REPORT_ID"].ToString())))
                {
                    htPackageID.Add(dsPackage.Tables[0].Rows[i]
                    ["REPORT_ID"].ToString(), "");

                    DataRow dr = dtPackage.NewRow();
                    dr["Package_ID"] = dsPackage.Tables[0].Rows[i]["PACKAGE_ID"].ToString();
                    dr["Package_Name"] = dsPackage.Tables[0].Rows[i]["Package"].ToString();
                    dtPackage.Rows.Add(dr);
                }*/
                if (!(htPackageID.Contains(dsPackage.Tables[0].Rows[i]
                    ["CODE_VALUE_ID"].ToString())))
                {
                    htPackageID.Add(dsPackage.Tables[0].Rows[i]
                    ["CODE_VALUE_ID"].ToString(), "");

                    DataRow dr = dtPackage.NewRow();
                    dr["Package_ID"] = dsPackage.Tables[0].Rows[i]["CODE_VALUE_ID"].ToString();
                    dr["Package_Name"] = dsPackage.Tables[0].Rows[i]["Description"].ToString();
                    dtPackage.Rows.Add(dr);
                }
            }

            //Populate Sub Package Table
            for (int i = 0;i< dsSubPackage.Tables[0].Rows.Count; i++)
            {
                DataRow dr = dtSubPackage.NewRow();
                dr["Sub_Package_ID"] = dsSubPackage.Tables[0].Rows[i]["CODE_VALUE_ID"].ToString();
               
                dr["Sub_Package_Name"] = dsSubPackage.Tables[0].Rows[i]["DESCRIPTION"].ToString();
                if (htSubPackageID_PackageID.Contains(dsSubPackage.Tables[0]
                    .Rows[i]["CODE_VALUE_ID"].ToString()))

                    dr["Package_ID"] = htSubPackageID_PackageID[dsSubPackage.Tables[0]
                    .Rows[i]["CODE_VALUE_ID"].ToString()];
                else
                    dr["Package_ID"] = "0";
                dtSubPackage.Rows.Add(dr);
            }

            ////Populate Reports Table
            //for (int i = 0; i < dsReports.Tables[0].Rows.Count; i++)
            //{
            //    DataRow dr = dtReports.NewRow();
            //    dr["Report_ID"] = dsReports.Tables[0].Rows[i]["REPORT_ID"].ToString();
            //    dr["Sub_Package_ID"] = dsReports.Tables[0].Rows[i]["SUB_PACKAGE_ID"].ToString();
            //    dtReports.Rows.Add(dr);
            //}

            //Populate Subscriptions Table
            for (int i = 0; i < dsSubscriptions.Tables[0].Rows.Count;i++ )
            {
                DataRow dr = dtSubscript.NewRow();
                dr["Report_ID"] = dsSubscriptions.Tables[0].Rows[i]["REPORT_ID"].ToString();
                dr["Report"] = dsSubscriptions.Tables[0].Rows[i]["REPORT"].ToString();
                dr["Domain"] = dsSubscriptions.Tables[0].Rows[i]["DOMAIN"].ToString();
                dtSubscript.Rows.Add(dr);
            }

            //Merge all tables in DataSet
            DataSet dsComp = new DataSet();

            dsComp.Tables.AddRange(new DataTable[] {dtPackage, dtSubPackage, dtReports, dtSubscript });

            dsComp.Relations.Add("Package2SubPackage", dsComp.Tables[0].Columns
                ["Package_ID"], dsComp.Tables[1].Columns["Package_ID"], false);
            dsComp.Relations.Add("SubPackage2Reports", dsComp.Tables[1].Columns
                ["Sub_Package_ID"], dsComp.Tables[2].Columns
                ["Sub_Package_ID"], false);
            
            dsComp.Relations.Add("Report2Subsciptions", dsComp.Tables[2].Columns
                ["REPORT_ID"], dsComp.Tables[3].Columns["Report_ID"]);

            dgrd.DataSource = dsComp;
            dgrd.DataMember = dsComp.Tables[0].TableName;

            this.dgrd.Model.Options.ResizeColsBehavior |= GridResizeCellsBehavior.InsideGrid;
            this.dgrd.TableStyle.WrapText = false;
            this.dgrd.Binder.EnableAddNew = false;
            this.dgrd.Properties.BackgroundColor = SystemColors.Window;

          //  dgrd.Model.HideCols["Package_Name"] = true;

            level0 = this.dgrd.Binder.RootHierarchyLevel;
            level1 = this.dgrd.Binder.AddRelation("Package2SubPackage");
            level2 = this.dgrd.Binder.AddRelation("SubPackage2Reports");
            level3 = this.dgrd.Binder.AddRelation("Report2Subsciptions");

            level1.ShowHeaders = false;
            level2.ShowHeaders = false;
            level2.ShowHeaders = false;

            this.dgrd.Model.Options.ResizeColsBehavior |= GridResizeCellsBehavior.InsideGrid;
            dgrd.Model.Options.DefaultGridBorderStyle = GridBorderStyle.None;
               
            #endregion

        }

        private void dgrd_CellClick(object sender, GridCellClickEventArgs e)
        {
            //if (noClick % 2 == 0)
            //// Hide Parent Header
            //{
            //    level0.ShowHeaders = false;
            //    level1.ShowHeaders = true;
            //}
            //else
            ////Hide Child Header
            //{
            //    level1.ShowHeaders = false;
            //    level0.ShowHeaders = true;
            //}
            //noClick++;
            if (noClick % 2 == 0)
            {
                dgrd.Model.HideCols["REPORT_DISPLAY_ID"] = true;
                dgrd.Model.HideCols["REPORT_NAME"] = false;
            }
            else
            {
                dgrd.Model.HideCols["REPORT_DISPLAY_ID"] = false;
                dgrd.Model.HideCols["REPORT_NAME"] = true;
            }
            noClick++;
        }
    }
}